"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@openapi-generator-plus/types");
const path_1 = __importDefault(require("path"));
const handlebars_templates_1 = require("@openapi-generator-plus/handlebars-templates");
const java_jaxrs_generator_common_1 = __importDefault(require("@openapi-generator-plus/java-jaxrs-generator-common"));
exports.createGenerator = (context) => {
    const base = java_jaxrs_generator_common_1.default(Object.assign(Object.assign({}, context), { loadAdditionalTemplates: async (hbs) => {
            await handlebars_templates_1.loadTemplates(path_1.default.resolve(__dirname, '../templates'), hbs);
            if (context.loadAdditionalTemplates) {
                await context.loadAdditionalTemplates(hbs);
            }
        }, additionalWatchPaths: (config) => {
            const result = [path_1.default.resolve(__dirname, '../templates')];
            if (context.additionalWatchPaths) {
                result.push(...context.additionalWatchPaths(config));
            }
            return result;
        }, transformOptions: (config, options) => {
            const result = Object.assign({}, options);
            return result;
        }, customiseRootContext: async (rootContext) => {
            rootContext.generatorClass = '@openapi-generator-plus/java-jaxrs-client-generator';
            if (context.customiseRootContext) {
                context.customiseRootContext(rootContext);
            }
        } }));
    return Object.assign(Object.assign({}, base), { generatorType: () => types_1.CodegenGeneratorType.CLIENT });
};
exports.default = exports.createGenerator;
